﻿define(["sitecore", "/-/speak/v1/odg/applib.js"], function (_sc, applib) {
  var dataEdit = _sc.Definitions.App.extend({
    initialized: function () {

      this.set("itemReferenceId", "");
      this.on("change:itemReferenceId", this.loadReference, this);

      this.set("item", null);
      this.on("change:item", this.loadItem, this);

      var pathColumn = $("[data-sc-id=PathColumn1]");
      if (pathColumn) {
        pathColumn.addClass("iteminfo-name");
      }
    },

    loadItem: function () {
      var item = this.get("item");
      if (item != null) {
        this.originalReferenceId = item["Item Reference"];
        this.set("itemReferenceId", item["Item Reference"]);
        this.FieldValue.set("text", item["Item Field"]);
      }
    },

    loadReference: function () {
      var referenceId = this.get("itemReferenceId");
      var item = this.get("item");
      item["Item Reference"] = this.get("itemReferenceId");

      var self = this;
      applib.getItemFromDatabase(referenceId, function (dataItem) {
        self.PathValue.set("text", dataItem.$path);
        self.PathValue.viewModel.$el.attr("title", dataItem.$path);
      });
    },

    acceptChanges: function () {
      var referenceId = this.get("itemReferenceId");
      this.originalReferenceId = referenceId;
    },

    hasChanges: function () {
      var referenceId = this.get("itemReferenceId");
      return this.originalReferenceId != referenceId;
    },

    isValid: function () {
      return true;
    },

    assignDataDialog: function () {
      _sc.trigger("assignDataDialog", this);
    }
  });

  return dataEdit;
});