﻿define(["sitecore", "/-/speak/v1/odg/applib.js"], function (_sc, applib) {
  var designPreviewsInfo = _sc.Definitions.App.extend({
    initialized: function (options) {
      this.set("item", null);
      this.on("change:item", this.fillDesignInfo, this);
      this.PagesDataSource.on("change:items", this.updateItemPages, this);
    },

    fillDesignInfo: function () {
      var item = this.get("item");
      if (!item) {
        return;
      }

      this.DesignNameValue.set("text", item.$displayName);
      this.DesignNameValue.viewModel.$el.attr("title", item.$displayName);

      var nameColumn = $("[data-sc-id=ValuesColumn0]");
      if (nameColumn) {
        nameColumn.addClass("iteminfo-name");
      }

      if (item.$pages) {
        this.DesignPreviewsListControl.set("items", item.$pages);
        this.PagesCountValue.set("text", item.$pages.length);
        return;
      }

      this.PagesDataSource.set("loadingItemId", item.itemId);
      this.PagesDataSource.set("language", item.$language);
      this.PagesDataSource.set("database", item.$database);
      this.PagesDataSource.set("query", "//*[@@id = '" + item["Project Reference"] + "']//*[@@templatekey='p_page']");
    },

    updateItemPages: function () {
      var items = this.PagesDataSource.get("items");
      var item = this.get("item");
      if (item && item.itemId == this.PagesDataSource.get("loadingItemId")) {
        this.DesignPreviewsListControl.set("items", items);
        this.PagesCountValue.set("text", items.length);
        item.$pages = items;
      }
    },
  });

  return designPreviewsInfo;
});