﻿define(["sitecore", "/-/speak/v1/odg/applib.js"], function (_sc, applib) {
  var imageEdit = _sc.Definitions.App.extend({
    initialized: function () {

      this.set("mediaReferenceId", "");
      this.on("change:mediaReferenceId", this.loadReference, this);

      this.set("item", null);
      this.on("change:item", this.loadItem, this);

      var pathColumn = $("[data-sc-id=ReferenceColumn1]");
      if (pathColumn) {
        pathColumn.addClass("iteminfo-name");
      }

      this.MediaBorder.viewModel.$el.addClass("selected-itemIcon");
    },

    loadItem: function () {
      var item = this.get("item");
      if (item != null) {
        this.originalReferenceId = item["MediaLibrary Reference"];
        this.set("mediaReferenceId", item["MediaLibrary Reference"]);
        this.MediaBorder.set("isVisible", item["MediaLibrary Reference"] != "");
      }
    },

    loadReference: function () {
      var mediaReferenceId = this.get("mediaReferenceId");
      var item = this.get("item");
      if (item["MediaLibrary Reference"] != mediaReferenceId) {
        item["MediaLibrary Reference"] = mediaReferenceId;
      }

      this.MediaBorder.set("isVisible", mediaReferenceId != "");
      var self = this;
      applib.getItemFromDatabase(mediaReferenceId, function (dataItem) {
        self.MediaImage.set("imageUrl", dataItem.$mediaurl);
        self.FieldValue.set("text", dataItem.$path);
        self.MediaImage.viewModel.$el.attr("title", dataItem.$path);
        self.FieldValue.viewModel.$el.attr("title", dataItem.$path);
      }, true);
    },

    acceptChanges: function () {
      if (this.hasChanges()) {
        var item = this.get("item");
        var mediaReferenceId = this.get("mediaReferenceId");

        applib.getChildren(item.itemId, function (items, total, data) {
          if (total != null) {
            var image = items[0].toModel();
            image.set("MediaLibrary Reference", mediaReferenceId);
            image.getUrl = applib.getUrl;
            image.save();
          }
        }, true);

        this.originalReferenceId = mediaReferenceId;
        return true;
      }

      return false;
    },

    hasChanges: function () {
      var mediaReferenceId = this.get("mediaReferenceId");
      return this.originalReferenceId != mediaReferenceId;
    },

    isValid: function () {
      return true;
    },

    assignImageDialog: function () {
      _sc.trigger("assignImageDialog", this);
    }
  });

  return imageEdit;
});