﻿define(["sitecore", "/-/speak/v1/odg/applib.js"], function (_sc, applib) {
  var itemInfo = _sc.Definitions.App.extend({
    initialize: function (options) {
      this.set("item", null);
      this.on("change:item", this.fillItemInfo, this);
    },

    fillItemInfo: function () {
      var item = this.get("item");
      if (!item) {
        return;
      }

      if (this.NameValue) {
        this.NameValue.set("text", item.$displayName);
        this.NameValue.viewModel.$el.attr("title", item.$displayName);
        var nameColumn = $("[data-sc-id=ValuesColumn0]");
        if (nameColumn) {
          nameColumn.addClass("iteminfo-name");
        }
      }

      var fieldValue;

      if (this.CreatedByValue) {
        fieldValue = item["__Created by"];
        if (fieldValue != "") {
          var self = this;
          $.get(applib.settings.navigation.commandRoutePrefix + "design/getuser?userName=" + fieldValue).done(function (data) {
            self.CreatedByValue.set("text", data.fullName != "" ? data.fullName : data.itemId);

            if (self.EmailValue) {
              self.EmailValue.set("text", data.email);
            }
          });
        } else {
          this.CreatedByValue.set("text", "");
          if (this.EmailValue) {
            this.EmailValue.set("text", "");
          }
        }
      }

      if (this.DateCreatedValue) {
        fieldValue = applib.getDateValue(item, "__Created");
        this.DateCreatedValue.set("text", fieldValue);
      }

      if (this.StartDateValue) {
        fieldValue = applib.getDateValue(item, "Start date");
        this.StartDateValue.set("text", fieldValue);
      }

      if (this.EndDateValue) {
        fieldValue = applib.getDateValue(item, "End date");
        this.EndDateValue.set("text", fieldValue);
      }
    }
  });

  return itemInfo;
});