﻿define(["sitecore"], function (_sc) {
  var assignImageDialog = _sc.Definitions.App.extend({
    initialized: function () {
      _sc.on("openAssignImageDialog", this.openDialog, this);
      _sc.on("sc-frame-message", function (value) {
        var modal = this.MediaDialog.viewModel.$el.data('modal');
        if (modal && modal.isShown) {
          this.proceedSelection(value);
        }
      }, this);
      this.MediaDialog.viewModel.$el.addClass("frameDialog noFooter");
    },

    openDialog: function (item, imageEditContext) {
      if (!item || item.$templateName != "Design Document") {
        return;
      }
      this.imageEditContext = imageEditContext;

      this.MediaDialog.show();
    },

    closePopup: function () {
      this.MediaDialog.hide();
    },

    proceedSelection: function (value) {
      if (value && value.length > 0 && this.imageEditContext) {
        this.imageEditContext.set("mediaReferenceId", value);
      }

      this.closePopup();
    }
  });

  return assignImageDialog;
});