﻿define(["sitecore", "/-/speak/v1/odg/applib.js"], function (_sc, applib) {
  _sc.Factories.createBaseComponent({
    name: "ItemInfoContent",
    base: "ControlBase",
    selector: ".sc-ItemInfoContent",
    attributes: [
            { name: "item", defaultValue: null },
            { name: "contentRenderingId", defaultValue: "", value: "$el.attr:data-sc-contentrenderingid" }
    ],

    initialize: function () {
      this._super();
      this.model.on("change:item", this.renderItem, this);
    },

    renderItem: function () {
      var item = this.model.get("item");

      if (this.model.contentControl != null) {
        this.model.contentControl.set("item", item);
      }
      else {
        var renderingId = this.model.get("contentRenderingId");
        var self = this;

        this.app.insertRendering(renderingId, { path: applib.settings.renderings.renderingRootPath, $el: this.$el }, function (control) {
          self.model.contentControl = control;
          self.model.contentControl.set("item", item);
        });
      }
    }
  });
});
