﻿/// <reference path="../../../../../../assets/lib/dist/sitecore.js" />

define(["sitecore", "/-/speak/v1/odg/applib.js"], function (_sc, applib) {
  return _sc.Definitions.App.extend({
    initialized: function () {
      $.ajaxSetup({ cache: false });
      this.on("closePopup", this.closePopup, this);
      _sc.on("view:collection", this.viewCollection, this);

      applib.addDialog(this, applib.settings.renderings.createCollectionDialog, "createDialog");

      this.MostUsedCollectionsListControl.on("change:selectedItemId", function () {
        this.setInfoPanel(this.MostUsedCollectionsListControl, this.RunningCollectionsListControl);
      }, this);

      this.RunningCollectionsListControl.on("change:selectedItemId", function () {
        this.setInfoPanel(this.RunningCollectionsListControl, this.MostUsedCollectionsListControl);
      }, this);

      applib.getItemAccess(applib.settings.rootFolderIds.designCollections, function (data) {
        this.CreateCollectionButton.set("isEnabled", data.canCreate);
      }, this);
    },

    setInfoPanel: function (currentListControl, otherListControl) {
      var selected = currentListControl.get("selectedItemId");
      var otherSelected = otherListControl.get("selectedItemId");

      var isSelected = selected && selected.length > 0;
      var isOtherSelected = otherSelected && otherSelected.length > 0;

      this.InfoSmartPanel.set("isOpen", isSelected || isOtherSelected);

      if (isSelected) {
        if (isOtherSelected) {
          otherListControl.set("selectedItemId", null);
        }

        this.SelectedGuid.set("text", selected);
        applib.getItemFromList(currentListControl, this.fillItemInfo, this);
      }
    },

    fillItemInfo: function (item) {
      this.ItemInfoContent.set("item", item);
    },

    editCollection: function () {
      var itemId = this.SelectedGuid.get("text");
      if (itemId && itemId.length > 0) {
        window.location = applib.settings.navigation.url + "editcollection?id=" + itemId + "&ref=DesignManager";
      }
    },

    viewCollection: function (itemId) {
      if (arguments.length == 0) {
        itemId = this.SelectedGuid.get("text");
      }
      if (itemId && itemId.length > 0) {
        window.location = applib.settings.navigation.url + "viewcollection?id=" + itemId + "&ref=DesignManager";
      }
    }
  });
});