﻿/// <reference path="../../../../../../assets/lib/dist/sitecore.js" />

define(["sitecore", "/-/speak/v1/odg/applib.js"], function (_sc, applib) {
  return _sc.Definitions.App.extend({
    initialized: function () {
      $.ajaxSetup({ cache: false });

      _sc.on("view:task", this.editTask, this);

      this.MostRecentCollectionsListControl.on("change:selectedItemId", function () {
        this.setInfoPanel(this.MostRecentCollectionsListControl, this.TasksListControl);
      }, this);

      this.TasksListControl.on("change:selectedItemId", function () {
        this.setInfoPanel(this.TasksListControl, this.MostRecentCollectionsListControl);
      }, this);

      applib.getItemAccess(applib.settings.rootFolderIds.designTasks, function (data) {
        this.ActionButton.set("isEnabled", data.canCreate);
      }, this);
    },

    setInfoPanel: function (currentListControl, otherListControl) {
      var selected = currentListControl.get("selectedItemId");

      if (selected && selected.length > 0) {
        var otherSelected = otherListControl.get("selectedItemId");

        if (otherSelected && otherSelected.length > 0) {
          otherListControl.set("selectedItemId", null);
        }

        var that = this;
        function fillItemInfo(item) {
          if (currentListControl == that.MostRecentCollectionsListControl) {
            that.CollectionInfoContent.set("item", item);
          } else {
            that.DesignInfoContent.set("item", item);
          }
        }

        applib.getItemFromList(currentListControl, fillItemInfo, this);
      }
    },

    createTask: function () {
      var itemId = this.MostRecentCollectionsListControl.get("selectedItemId");
      if (itemId && itemId.length > 0) {
        var self = this;
        applib.getCollectionState(itemId, function (result) {
          if (result.isActive) {
            window.location = applib.settings.navigation.url + "adddocument?cid=" + itemId + "&ref=DocumentPublisher";
          }
          else {
            alert(self.CollectionNotRunningText.get("text"));
          }
        });

      }
    },

    viewCollection: function () {
      var itemId = this.MostRecentCollectionsListControl.get("selectedItemId");
      if (itemId && itemId.length > 0) {
        window.location = applib.settings.navigation.url + "salesviewcollection?id=" + itemId + "&ref=DocumentPublisher";
      }
    },

    editTask: function (itemId) {
      if (arguments.length == 0) {
        itemId = this.TasksListControl.get("selectedItemId");
      }
      if (itemId != null && itemId != "") {
        window.location = applib.settings.navigation.url + "editdocument?id=" + itemId + "&ref=DocumentPublisher";
      }
    }
  });
});