﻿define(["sitecore", "/-/speak/v1/odg/applib.js"], function (_sc, applib) {
  var salesViewCollection = _sc.Definitions.App.extend({
    initialized: function () {
      $.ajaxSetup({ cache: false });

      var app = this;

      var guid = applib.getUrlParameter("id");
      if (guid != "") {
        applib.getItemFromDatabase(guid, loadItem);
      } else {
        this.back();
      }

      function loadItem(item) {
        if (item == null) {
          app.back();
        }

        app.item = item;
        app.updateInfo();
      }

      applib.getItemAccess(applib.settings.rootFolderIds.designTasks, function (data) {
        this.CreateDesignButton.set("isEnabled", data.canCreate);
      }, this);

      this.DesignsListControl.on("change:selectedItemId", this.setInfoPanel, this);
    },

    updateInfo: function () {
      if (!this.item || this.item.$templateName != "Design Collection") {
        return;
      }
      this.ItemInfoContent.set("item", this.item);
    },

    setInfoPanel: function () {
      var selected = this.DesignsListControl.get("selectedItemId");
      if (selected && selected.length > 0) {
        applib.getItemFromList(this.DesignsListControl, this.fillDesignInfo, this);
      }
    },

    fillDesignInfo: function (item) {
      this.DesignInfoContent.set("item", item);
    },

    toggleView: function () {
      var isDetailsList = this.DetailListToggleButton.get("isEnabled") && this.DetailListToggleButton.get("isOpen");
      if (isDetailsList) {
        this.DesignsListControl.viewModel.setDetailListView();
      } else {
        this.DesignsListControl.viewModel.setIconView();
      }

      this.DetailListToggleButton.set("isEnabled", !isDetailsList);
      this.DetailListToggleButton.set("isOpen", isDetailsList);
      this.IconListToggleButton.set("isEnabled", isDetailsList);
      this.IconListToggleButton.set("isOpen", !isDetailsList);
    },

    createDesign: function () {
      var selectedItemId = this.DesignsListControl.get("selectedItemId");

      var withDesign = "";
      if (selectedItemId != "") {
        withDesign = "&did=" + selectedItemId;
      }

      var self = this;
      applib.getCollectionState(this.item.itemId, function (result) {
        if (result.isActive) {
          window.location = applib.settings.navigation.url + "adddocument?cid=" + self.item.itemId + withDesign;
        }
        else {
          alert(self.CollectionNotRunningText.get("text"));
        }
      });
    },

    back: function () {
      var ref = applib.getUrlParameter("ref");
      if (ref == "") {
        ref = "DocumentPublisher";
      }

      if (ref == "AddTask") {
        this.createDesign();
      }
      else {
        window.location = applib.settings.navigation.url + ref;
      }
    }
  });

  return salesViewCollection;
});